-----------------------------------------------------------------
-- Header
-----------------------------------------------------------------
	do
		--Creates a new UI frame called "SexyMapTrackerButtonFix"
		SexyMapTrackerButtonFix = CreateFrame("Frame", "SexyMapTrackerButtonFix", UIParent);
		-- Sets the name of the addon
		SexyMapTrackerButtonFix.Name = "SexyMapTrackerButtonFix";
		-- Pulls back the title of the addon from the TOC file
		SexyMapTrackerButtonFix.Title = GetAddOnMetadata(SexyMapTrackerButtonFix.Name, "Title");
		-- Pulls back the current version of the file from the TOC file
		SexyMapTrackerButtonFix.Version = GetAddOnMetadata(SexyMapTrackerButtonFix.Name, "Version");
		-- Says what stage the addon loading is at.
		SexyMapTrackerButtonFix.LoadedStatus = {};
		-- Say that the addon has not loaded yet.
		SexyMapTrackerButtonFix.LoadedStatus["Initialized"] = 0;
		-- Specifies what level the addon is "Running"
		SexyMapTrackerButtonFix.LoadedStatus["RunLevel"] = 1;
	end;
-----------------------------------------------------------------


-----------------------------------------------------------------
-- Libraries
-----------------------------------------------------------------
	-- Registering local variables outside hidder do
	local ZasName, Msg, ErrMsg, DBugMsg, ErrDBugMsg, InitDBug, ZMC_COLOURS, ZMC_Settings, L, AddonVersion;
	do
		-- Setup the Localisation library
		L = LibStub("AceLocale-3.0"):GetLocale(SexyMapTrackerButtonFix.Name, true);
		-- Just to store this one until we use it
		local GetAddonVersion;
		-- Get some useful functions and store them locally to make it easyer to use them
		GetAddonVersion = LibStub("LibZasUsefulFuncs-0.1"):GetFunctions("GetAddonVersion");
		-- Pull back the addon version and version type
		SexyMapTrackerButtonFix.CurAddOnVer, SexyMapTrackerButtonFix.CurAddOnVerType, SexyMapTrackerButtonFix.AddonVerTypeColour = GetAddonVersion(SexyMapTrackerButtonFix.Name, true);
		-------------------------------------------------------------------------------------------------------------------
		-- Library: Zasurus' Message Control
		-------------------------------------------------------------------------------------------------------------------
			Msg, ErrMsg, DBugMsg, ErrDBugMsg, InitDBug, ZMC_COLOURS, ZMC_Settings = LibStub("LibZasMsgCtr-1.1"):Initialize(SexyMapTrackerButtonFix, nil, "COLOUR_LTBLUE");
			
			-- Store the coloured version of "Zasurus"
			ZasName = ZMC_COLOURS.BLUE.."Zas"..ZMC_COLOURS.CLOSE..ZMC_COLOURS.LTBLUE.."ur"..ZMC_COLOURS.CLOSE..ZMC_COLOURS.LTGREEN.."us"..ZMC_COLOURS.CLOSE;
			-- Store the colour of the addon version
			AddonVersion = ZMC_COLOURS[SexyMapTrackerButtonFix.AddonVerTypeColour].."V"..SexyMapTrackerButtonFix.CurAddOnVer.." "..SexyMapTrackerButtonFix.CurAddOnVerType..ZMC_COLOURS.CLOSE;
			-----------------------------------------------------------
			-- Valid Msg Formats
			--[[-------------------------------------------------------
				Msg(sMessage[, bSimple, FrameOverride]); -- This is the original format.
				ErrMsg(sMessage[, bSimple, FrameOverride]); -- For displaying standard ERROR messages to the user. (In RED)
				DBugMsg(sMessage[, bSimple, FrameOverride]); -- For displaying debugging messages to the user.
				ErrDBugMsg(sMessage[, bSimple, FrameOverride]); -- For displaying debugging ERROR messages to the user. (In RED)
			-----------------------------------------------------------
			
			-----------------------------------------------------------
			-- AddOn Setting Values
			-----------------------------------------------------------
				ZMCOpt.DefaultAddonNameColour = Default Colour for the AddOn's Name/Alias Before Standard Messages
				ZMCOpt.DefaultMsgColour = Default Colour for Standard Messages
				ZMCOpt.DefaultDBugMsgColour = Default Colour for Standard Debug Messages
				ZMCOpt.DefaultErrorMsgColour = Default Colour for Standard Err Messages
				ZMCOpt.DefaultDBugErrorMsgColour = Default Colour for Debug Err Messages
				
				ZMCOpt.MsgFrameNum = Sets the frame that messages will be DBugMsged in by default (If not overwritten on calling msg function).
				ZMCOpt.DebugMsgFrameNum = Stores the addon Name for the msg function. This is what is DBugMsged at the start of the message
			--]]-------------------------------------------------------
		-------------------------------------------------------------------------------------------------------------------
	end;
-----------------------------------------------------------------


-------------------------------------------------------------------------------------------
-- Tidy's up SexyMap's Keybinding Description - Something extra and FREE! ;)
-------------------------------------------------------------------------------------------
do
	-- Correct SexyMap's keybinds in keybinding menu
	BINDING_HEADER_SexyMap = "SexyMap"
	BINDING_NAME_TOGGLESEXYMAPGATHERMAP = "Toggle SexyMap GatherMap (HUD)"
end;
-------------------------------------------------------------------------------------------


-- Runs when any event's we are registered for occure
function SexyMapTrackerButtonFix:OnEvent(Event, Arg1, Arg2)
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:OnEvent("..tostring(Event)..") SexyMapTrackerButtonFix.LoadedStatus[Initialized] = "..tostring(SexyMapTrackerButtonFix.LoadedStatus["Initialized"]).." Arg1(AddOnName) = "..tostring(Arg1).. " and SexyMapTrackerButtonFix.LoadedStatus[RunLevel] = "..tostring(SexyMapTrackerButtonFix.LoadedStatus["RunLevel"]));
	-- This addon has all been loaded into memmory
	if (Event == "ADDON_LOADED" and SexyMapTrackerButtonFix.LoadedStatus["Initialized"] == 0 and Arg1 == "SexyMapTrackerButtonFix") then
		DBugMsg("Event == ADDON_LOADED and SexyMapTrackerButtonFix.LoadedStatus[Initialized] == "..tostring(SexyMapTrackerButtonFix.LoadedStatus["Initialized"]).." and Arg1(AddOnName) == SexyMapTrackerButtonFix");
		-- Start initializing the addon
		SexyMapTrackerButtonFix:Initialize();
	end;
end;

-- Initialize the addon
function SexyMapTrackerButtonFix:Initialize()
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:Initialize()");
	
	-- Stops monitoring the "ADDON_LOADED" event as we don't need it any more
	SexyMapTrackerButtonFix:UnregisterEvent("ADDON_LOADED");
	
	SexyMapTrackerButtonFix:InitLevel(1); -- Start Second section of setup.
end;

-- Initializes the addon to the level specified (used to set specific variables etc as the addon loads up)
function SexyMapTrackerButtonFix:InitLevel(Level)
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:InitLevel(Level = "..tostring(Level)..")");
	
	DBugMsg("Request to initializing addon from level  = '"..tostring(SexyMapTrackerButtonFix.LoadedStatus["Initialized"]).."' to level = '"..tostring(Level).."'");
	
	if (Level == 1) and (SexyMapTrackerButtonFix.LoadedStatus["Initialized"] == 0) then
		DBugMsg("Setting Level to 1...");
		-- Initialize the variables
		SexyMapTrackerButtonFix:VarInit();
		
		SexyMapTrackerButtonFix.LoadedStatus["Initialized"] = Level;
		
		-- Fixes SexyMap's Button Mod to it releases the Tracking Button - Main reason for addon...
		SexyMapTrackerButtonFix:FixSexyMapFixTrackingAnchoring();
		
		-- Ensures SexyMap isn't messing with the buttons still.
		SexyMapTrackerButtonFix:DisableSexyMapButtons();
	else
		ErrMsg(L["Addon's current level"].." ("..tostring(SexyMapTrackerButtonFix.LoadedStatus["Initialized"])..") "..L["doesn't match expected level to progress to level"].." ("..tostring(Level)..") "..L["or requested level isn't known... Aborting!'"]);
	end;
end;

-- Initialize the variables (CONTAINS MOST DEFAULTS)
function SexyMapTrackerButtonFix:VarInit()
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:VarInit()");
	
	-- Initialize SexyMapTrackerButtonFix's Main Options array
	-- SexyMapTrackerButtonFix_Options = SexyMapTrackerButtonFix_Options or {};
	-- Initialize SexyMapTrackerButtonFix's Character Specific Options Array
	-- SexyMapTrackerButtonFix_CharOptions = SexyMapTrackerButtonFix_CharOptions or {};
	
	-- Say that the addon variables have now all been initialized
	SexyMapTrackerButtonFix.LoadedStatus["AddonVariables"] = true;
end

-- Fixes SexyMap's Button Mod to it releases the Tracking Button - Main reason for addon...
function SexyMapTrackerButtonFix:FixSexyMapFixTrackingAnchoring()
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:FixSexyMapFixTrackingAnchoring()");
	
	-- grab the sexymap buttons module
	local SexyMapButMod = SexyMap:GetModule("Buttons"); 
	-- replace the sexymaps button module's "FixTrackingAnchoring()" function with our own that doesn't mess things up!
	function SexyMapButMod:FixTrackingAnchoring()
		if ElkBuffBars and ElkBuffBars.db.profile.hidetrackingframe then
			DEFAULT_CHAT_FRAME:AddMessage("|cffff0000!! Warning !!!|r Elkano's Buff Bars is set to hide the tracking button. This will hide your tracking texture. Run |cffffcc00/ebb config|r and uncheck |cffffcc00Hide minimap tracking frame|r to fix this.");
		end;
	end;
end;

-- Ensures SexyMap isn't messing with the buttons still.
function SexyMapTrackerButtonFix:DisableSexyMapButtons()
	-------------------------------------------------
	-- ZMC Debug: If bDBug is set to true all of the
	-- debug msgs in THIS function will apear!
	-------------------------------------------------
	-- local bDBug = true; -- Uncomment this to debug
	local DBugMsg, ErrDBugMsg, DBState = InitDBug(bDBug);
	-------------------------------------------------
	
	DBugMsg("SexyMapTrackerButtonFix:DisableSexyMapButtons()");
	
	-- Pull back the SexyMap Button Module
	local SexyMapButton = SexyMap:GetModule("Buttons");
	
	DBugMsg("Replacing SexyMap.db.RegisterNamespace")
	-- Temporarly Replace SexyMap.db.RegisterNamespace function with ours to prevent problems
	local original_AnAddon_Module_FuncName2 = SexyMap.db.RegisterNamespace;
	function SexyMap.db:RegisterNamespace()
		DBugMsg("SexyMap.db:RegisterNamespace()");
		return SexyMapButton.db;
	end
	DBugMsg("Replacing SexyMap.RegisterModuleOptions")
	-- Temporarly Replace SexyMap.RegisterModuleOptions function with ours to grab options!
	local original_AnAddon_Module_FuncName = SexyMap.RegisterModuleOptions;
	function SexyMap:RegisterModuleOptions(...)
		local _, Options = ...;
		DBugMsg("SexyMap:RegisterModuleOptions(..., Options = "..tostring(Options)..", ...)");
		-- Disable SexyMap's Button Visibilty Control
		Options.args.controlVisibility.set(nil,false)
		-- Disable SexyMap's Button Dragging Control
		Options.args.enableDragging.set(nil,false)
		-- Disable them so user can't turn it back on!
		Options.args.controlVisibility.disabled = function() return true; end;
		Options.args.enableDragging.disabled = function() return true; end;
		-- Update text so the user knows what why they can't enable it
		Options.args.controlVisibility.name = Options.args.controlVisibility.name..ZMC_COLOURS.RED.." ("..L["DISABLED BY"]..ZMC_COLOURS.CLOSE.." "..ZMC_Settings.DefaultAddonNameColour..SexyMapTrackerButtonFix.Name..ZMC_COLOURS.CLOSE..ZMC_COLOURS.RED.."!)"..ZMC_COLOURS.CLOSE
		Options.args.enableDragging.name = Options.args.enableDragging.name..ZMC_COLOURS.RED.." ("..L["DISABLED BY"]..ZMC_COLOURS.CLOSE.." "..ZMC_Settings.DefaultAddonNameColour..SexyMapTrackerButtonFix.Name..ZMC_COLOURS.CLOSE..ZMC_COLOURS.RED.."!)"..ZMC_COLOURS.CLOSE
	end
	DBugMsg("Running - SexyMapButton:OnInitialize()")
	-- Run SexyMap Button Modules OnInitialize() function to get it to pass the options though
	SexyMapButton:OnInitialize();
	DBugMsg("Putting back")
	-- Restore the original functions so nobody notices!
	SexyMap.RegisterModuleOptions = original_AnAddon_Module_FuncName;
	SexyMap.db.RegisterNamespace = original_AnAddon_Module_FuncName2;
end;


-- Catch when this addon has finished loading
SexyMapTrackerButtonFix:RegisterEvent("ADDON_LOADED");
SexyMapTrackerButtonFix:SetScript("OnEvent", SexyMapTrackerButtonFix.OnEvent);