﻿--[[
    Name:           Titan RecipeBook
	Description:	Titan Panel plugin for RecipeBook
	  RecipeBook created by Ayradyss
    Author:         Suddendeath2000
    Version:        3.3.5
    ]]--
   
RBID = "RecipeBook"   
RBVersion = "3.3.5"
RBC1 = "|cffffffff"
RBC2 = "|cff00ff00"
RBC3 = "|cff999999"
RBC4 = "|cffffcc00"
 
function TitanPanelRecipeBookButton_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(RBC1.."Titan Panel "..RBC2.."["..RBID.."] "..RBC1.." v"..RBC2..RBVersion.." "..RBC1.."by |cff999999Suddendeath2000")

    self.registry = {
		id = RECIPEBOOK_MENU_MAIN,
	    version = RBVersion,
        menuText = RECIPEBOOK_MENU_MAIN,
        buttonTextFunction = "TitanPanelRecipeBookButton_GetButtonText",	
        category = "Interface",
        tooltipTitle = RBC4..RECIPEBOOK_MENU_MAIN,
		tooltipTextFunction = "TitanPanelRecipeBookButton_GetTooltipText",
	    icon = "Interface\\AddOns\\TitanRecipeBook\\TitanRecipeBook",
        iconButtonWidth = 16,
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,			
            ShowTooltipText = 1,
            ShowMenuOptions = 1,
            ShowAdvancedMenus = 1,
            DisplayOnRightSide = 1,
    }}
end

 --Puts Button Name on Button--
function TitanPanelRecipeBookButton_GetButtonText()
    return RECIPEBOOK_MENU_MAIN
end        

--Information Shown on Button Mouseover--
function TitanPanelRecipeBookButton_GetTooltipText()
	return RBC2.."Left-click to Toggle Skill Browse Frame\n"..RBC2.."Right-click to Choose Another Frame"
end

function TitanPanelRecipeBookButton_OnClick(self, button)
    if button == "LeftButton" then RBMM:ClickButton(arg1)
      elseif button == "RightButton" then TitanPanelRightClickMenu_PrepareRecipeBookMenu() 
  end
end

function TitanPanelRightClickMenu_PrepareRecipeBookMenu(self, button)         
    local info = {}
    
    if  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == RECIPEBOOK_MM_SHARESUBTITLE )then
      TitanPanelRightClickMenu_AddTitle(RECIPEBOOK_MM_SHARESUBTITLE, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = RECIPEBOOK_MENU_REQUEST
        info.func = RBMM.ShareData
        info.arg1 = "request"
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = RECIPEBOOK_MENU_SHARESELF
        info.func = RBMM.ShareData
        info.arg1 = "self"
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = RECIPEBOOK_MENU_SHAREALL
        info.func = RBMM.ShareData
        info.arg1 = "all"
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
      
      else
    
        TitanPanelRightClickMenu_AddTitle(RECIPEBOOK_MENU_MAIN)
        TitanPanelRightClickMenu_AddSpacer()
        
     
        info.text = RECIPEBOOK_SFTAB_SEARCH
        info.func = RBUI.ShowSearchFrame
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
		info.text = RECIPEBOOK_SFTAB_BROWSE
		info.func = RBUI.ShowBrowseFrame
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

		info.text = RECIPEBOOK_SFTAB_SHARING
		info.func = RBUI.ShowShareFrame
	  	UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

		info.text = RECIPEBOOK_SFTAB_BANKING
		info.func = RBUI.ShowBankFrame
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = RECIPEBOOK_SFTAB_OPTIONS
		info.func = RBUI.ShowOptionsFrame
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = RECIPEBOOK_SFTAB_COLORS
        info.func = RBUI.ShowColorsFrame
        UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = RECIPEBOOK_MM_SHARETITLE
        info.value = RECIPEBOOK_MM_SHARESUBTITLE
        info.hasArrow = 1
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end
end