TITAN_SELLOMATIC_ID = "SellOMatic";
TITAN_SELLOMATIC_FREQUENCY = 1;
TITAN_SELLOMATIC_BUTTON_LABEL = "SOM: "
TITAN_SELLOMATIC_VERSION = "0.1";
TITAN_SELLOMATIC_MENU_TEXT = "Sell-O-Matic";
TITAN_SELLOMATIC_TOOLTIP = "Sell-O-Matic";
TITAN_SELLOMATIC_SHOWADDBOX = "Add Items to SOM Database";
TITAN_SELLOMATIC_SHOWSELLLIST = "Display Sell List"
TITAN_SELLOMATIC_USESELLLIST = "Turn on SOM Sell List"
TITAN_SELLOMATIC_NOUSESELLLIST = "Turn off SOM Sell List"

local TITAN_SELLOMATIC_BUSY;
local Global_TrashItems = {};
local Global_ttlgold = 0;
TitanSOMExists = true;


function TitanPanelSellOMaticButton_OnLoad()
	this.registry = { 
		id = TITAN_SELLOMATIC_ID,
		version = TITAN_SELLOMATIC_VERSION,
		menuText = TITAN_SELLOMATIC_MENU_TEXT,
		buttonTextFunction = "TitanPanelSellOMaticButton_GetButtonText",		
		category = "Information",
		tooltipTitle = TITAN_SELLOMATIC_TOOLTIP,
		tooltipTextFunction = "TitanPanelSellOMaticButton_GetTooltipText",
		savedVariables = {
			ShowLabelText = 1
		}
	};

	this:RegisterEvent("BAG_UPDATE");
end

function TitanPanelSellOMaticButton_OnEvent() 
	if (event == "BAG_UPDATE") then
		TitanPanelButton_UpdateButton(TITAN_SELLOMATIC_ID);
	end
end

function TitanPanelSellOMaticButton_ForceUpdate()
	TitanPanelButton_UpdateButton(TITAN_SELLOMATIC_ID);
end

function TitanPanelSellOMaticButton_Update()
	if ( TITAN_SELLOMATIC_BUSY ) then
		return true;
	end
	local TrashItems = {};
	TITAN_SELLOMATIC_BUSY = true;
	
	local ttlgold = 0;
	for bag = 0,4,1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			local name = GetContainerItemLink(bag,slot);
			if name then
				if not name then DEFAULT_CHAT_FRAME:AddMessage("has no name", 1, 0,0,0); end
				local sName, _, iRarity, _, _, _, _, _, _, _ = GetItemInfo(name);
				if SOM.db.profile.list then
					for i,v in ipairs(SOM.db.profile.sellItems) do
						if name and string.find(name,SOM.db.profile.sellItems[i]) or name == v then
							TrashItems[sName] = {VendorSell_GetSellValue(name), GetItemCount(name, false), iRarity};
						end
					end
				end
				if name and string.find(name,"ff9d9d9d") then
					TrashItems[sName] = {VendorSell_GetSellValue(name), GetItemCount(name, false), iRarity};
				end
			end
		end
	end
	
	for name, value in pairs(TrashItems) do
		ttlgold = ttlgold + (value[1] * value[2]);
	end
	Global_TrashItems = TrashItems;
	Global_ttlgold = ttlgold;
	TITAN_SELLOMATIC_BUSY = false;
	return TitanPanelSellOMaticButton_SplitMoney(ttlgold);
end

function TitanPanelSellOMaticButton_GetButtonText()
	return TITAN_SELLOMATIC_BUTTON_LABEL, TitanPanelSellOMaticButton_Update();
end

function TitanPanelSellOMaticButton_GetTooltipText()
	local display = "";
	for sName, value in pairs(Global_TrashItems) do 
		if value[1] == 0 then
			display = display .. value[2] .. "x [" .. TitanPanelSellOMaticButton_GetItemColor(sName, value[3]) .. "]\tNo Sell Value\n"
		else
			display = display .. value[2] .. "x [" .. TitanPanelSellOMaticButton_GetItemColor(sName, value[3]) .. "]\t" .. TitanPanelSellOMaticButton_SplitMoney(value[1] * value[2]) .. "\n"
		end
	end
	display = display .. "\nTotal:\t" .. TitanPanelSellOMaticButton_SplitMoney(Global_ttlgold);
	return display;
end

function TitanPanelRightClickMenu_PrepareSellOMaticMenu()
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_SELLOMATIC_ID].menuText);
	TitanPanelRightClickMenu_AddCommand(TITAN_SELLOMATIC_SHOWADDBOX, TITAN_SELLOMATIC_ID, "TitanPanelSellOMaticButton_ShowAddBox");
	TitanPanelRightClickMenu_AddSpacer();	
	if SOM.db.profile.list then
		TitanPanelRightClickMenu_AddCommand(TITAN_SELLOMATIC_NOUSESELLLIST, TITAN_SELLOMATIC_ID, "TitanPanelSellOMaticButton_ToggleSellList");
		TitanPanelRightClickMenu_AddCommand(TITAN_SELLOMATIC_SHOWSELLLIST, TITAN_SELLOMATIC_ID, "TitanPanelSellOMaticButton_ShowSellList");
	else
		TitanPanelRightClickMenu_AddCommand(TITAN_SELLOMATIC_USESELLLIST, TITAN_SELLOMATIC_ID, "TitanPanelSellOMaticButton_ToggleSellList");
	end 
	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_SELLOMATIC_ID);
	TitanPanelRightClickMenu_AddSpacer();	
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_SELLOMATIC_ID, TITAN_PANEL_MENU_FUNC_HIDE);
end

function TitanPanelSellOMaticButton_ShowAddBox()
	SOM:ShowAddBox()
end

function TitanPanelSellOMaticButton_ShowSellList()
	SOM:ShowSOMTable()
end

function TitanPanelSellOMaticButton_ToggleSellList()
	SOM:ToggleList()
	TitanPanelSellOMaticButton_ForceUpdate()
end

function TitanPanelSellOMaticButton_SplitMoney(money)
	-- Non-negative money only
	if (money >= 0) then
		local total = "";
		local gold = floor(money / (COPPER_PER_SILVER * SILVER_PER_GOLD));
		local silver = floor((money - (gold * COPPER_PER_SILVER * SILVER_PER_GOLD)) / COPPER_PER_SILVER);
		local copper = mod(money, COPPER_PER_SILVER);
		if gold > 0 then
			total = "|cffd2b114" .. gold .. "g|r, " .. "|cffffffff" .. silver .. "s|r, " .. "|cffd27530" .. copper .. "c|r";
		elseif silver > 0 then
			total = "|cffffffff" .. silver .. "s|r, " .. "|cffd27530" .. copper .. "c|r";
		else
			total = "|cffd27530" .. copper .. "c|r";
		end
		return total;
	end
end	

function TitanPanelSellOMaticButton_GetItemColor(sName, iRarity)
	if (iRarity == 0 ) then
		return "|cffaaaaaa" .. sName .. "|r";
	elseif (iRarity == 1 ) then
		return "|cffffffff" .. sName .. "|r";
	elseif (iRarity == 2 ) then
		return "|cff00ff00" .. sName .. "|r";
	elseif (iRarity == 3 ) then
		return "|cff0000ff" .. sName .. "|r";
	elseif (iRarity == 4 ) then
		return "|cffa436ee" .. sName .. "|r";
	elseif (iRarity == 5 ) then
		return "|cffff8800" .. sName .. "|r";
	elseif (iRarity == 6) then
		return "|cffff0000" .. sName .. "|r";
	else 
		return sName; 
	end
end
